Subject: Re: bug#20140: 24.4; M17n shaper output rejected

From: Richard Wordingham <[email-masked]>
Date: Wed, 16 Feb 2022 19:01:12 +0000

On Wed, 16 Feb 2022 15:15:46 +0200
Eli Zaretskii <[email-masked]> wrote:

> > Date: Tue, 15 Feb 2022 21:06:05 +0000
> > From: Richard Wordingham <[email-masked]>
> > Cc: [email-masked], [email-masked]
> >   
> > > > Not off the top of my head, but compare لحج with the
> > > > presentation form ‎ﳊ U+FCCA ARABIC LIGATURE LAM WITH HAH
> > > > INITIAL FORM for the first two letters.  The lam part is a
> > > > vertical line in the middle of the glyph; the 'hah' part forms
> > > > the lower part of the glyph.    
> > > 
> > > They look identical here (using the default Courier New font).
> > > With what font did you think they will look wrong?  
> > 
> > In the Courier New font in Windows 10 of 2017 (+ automatic updates),
> > U+FCCA looks like the image in the Unicode code chart, and bears
> > little resemblance to the righthand two thirds of <U+0644, U+062D,
> > U+062C>. In keeping with its Latin part, the sequence of three
> > characters looks as one would expect from a typewriter when one
> > enters text letter by letter.  
> 
> It sounds like Courier New in Windows 10 was "improved" by removing
> the capability of ligating those 2 characters.  On Windows XP, their
> standard Courier New shows the first 2 characters ligate into a single
> glyph, which looks just like U+FCCA, but on Windows 10 they don't
> ligate.  I don't know why is that; perhaps Arabic typesetting experts
> decided these should not ligate?
> 
> > I must admit I'm having trouble laying my hand on a font which
> > does these ligatures.  
> 
> Try the Arabic Typesetting font, there I see on Windows 10 that the
> first 2 characters look like U+FCCA.
> 
> IOW, this is a font issue, not an Emacs or HarfBuzz issue.

Arabic Typesetting seems not to come in an evaluation copy of Windows
10.  And yes, the issue is that some fonts probably don't work well with
Emacs.  Irritating, but mostly not a big problem.

Richard.